> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Ingest usage events for a meter

POST https://rest.test.zuora.com/usage/bulk/{meterGlobalId}
Content-Type: application/json

Ingests usage events directly into Zuora Mediation in real time. You can send a single event or batch multiple events in a JSON array to optimize throughput. Each event must conform to the meter's event schema. This operation is supported only for meters that use the Streaming API as their source in Zuora Mediation. You can use this API to bulk-ingest events into a meter only when the meter's source is configured as a Streaming API operator. For meters that use other sources, use the appropriate ingestion mechanism for that source instead.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/mediation/data-ingestion/ingest-usage-events

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `meterGlobalId` (string, required) — The global ID of the meter.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).

### Body (application/json)

This endpoint expects a Data Ingestion_ingestUsageEvents_Request.

- `Data Ingestion_ingestUsageEvents_Request`

## Response

### 200

Usage event(s) ingested successfully.

- `success` (boolean, optional) — Whether the ingestion was successful.
- `message` (string, optional) — Response message with details.

## Errors

### 400 Bad Request Error

Bad request due to validation or business logic errors.

- `errors` (list of ProxyBadRequestResponseErrorsItems, optional)
- `success` (boolean, optional)

### 401 Unauthorized Error

Unauthorized request.

- `message` (string, required) — Error message describing the problem.

### 404 Not Found Error

Resource not found.

- `message` (string, required) — Error message describing the problem.

### 413 Content Too Large Error

Payload too large.

- `message` (string, required) — Error message describing the problem.

### 429 Too Many Requests Error

Too many requests.

- `message` (string, required) — Error message describing the problem.

### 500 Internal Server Error

Internal server error.

- `reasons` (list of ErrorResponseReasonsItems, optional)

## Types

### StreamingEvent

A usage event to be ingested into Zuora Mediation.

- `CustomerId` (string, required) — Unique identifier for the customer.
- `UsageIdentifier` (string, required) — Identifier for the usage type.
- `UsageDate` (datetime, required) — Date and time when the usage occurred.
- `Quantity` (double, required) — Quantity of usage.

### ProxyBadRequestResponseErrorsItems

- `code` (string, optional) — Machine-readable error code identifying the failure type.
- `message` (string, optional) — Human-readable description of the error that provides more context about what went wrong.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "CustomerId": "CUST-789456123",
  "Quantity": 15.75,
  "UsageDate": "2024-01-15T09:30:00Z",
  "UsageIdentifier": "DATA_TRANSFER_GB"
}
```

**Response**

```json
{
  "success": true,
  "message": "Usage events ingested successfully."
}
```

**SDK Code**

```python
import requests

url = "https://rest.test.zuora.com/usage/bulk/meterGlobalId"

payload = {
    "CustomerId": "CUST-789456123",
    "Quantity": 15.75,
    "UsageDate": "2024-01-15T09:30:00Z",
    "UsageIdentifier": "DATA_TRANSFER_GB"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://rest.test.zuora.com/usage/bulk/meterGlobalId';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"CustomerId":"CUST-789456123","Quantity":15.75,"UsageDate":"2024-01-15T09:30:00Z","UsageIdentifier":"DATA_TRANSFER_GB"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/usage/bulk/meterGlobalId"

	payload := strings.NewReader("{\n  \"CustomerId\": \"CUST-789456123\",\n  \"Quantity\": 15.75,\n  \"UsageDate\": \"2024-01-15T09:30:00Z\",\n  \"UsageIdentifier\": \"DATA_TRANSFER_GB\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/usage/bulk/meterGlobalId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"CustomerId\": \"CUST-789456123\",\n  \"Quantity\": 15.75,\n  \"UsageDate\": \"2024-01-15T09:30:00Z\",\n  \"UsageIdentifier\": \"DATA_TRANSFER_GB\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/usage/bulk/meterGlobalId")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"CustomerId\": \"CUST-789456123\",\n  \"Quantity\": 15.75,\n  \"UsageDate\": \"2024-01-15T09:30:00Z\",\n  \"UsageIdentifier\": \"DATA_TRANSFER_GB\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/usage/bulk/meterGlobalId', [
  'body' => '{
  "CustomerId": "CUST-789456123",
  "Quantity": 15.75,
  "UsageDate": "2024-01-15T09:30:00Z",
  "UsageIdentifier": "DATA_TRANSFER_GB"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/usage/bulk/meterGlobalId");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"CustomerId\": \"CUST-789456123\",\n  \"Quantity\": 15.75,\n  \"UsageDate\": \"2024-01-15T09:30:00Z\",\n  \"UsageIdentifier\": \"DATA_TRANSFER_GB\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "CustomerId": "CUST-789456123",
  "Quantity": 15.75,
  "UsageDate": "2024-01-15T09:30:00Z",
  "UsageIdentifier": "DATA_TRANSFER_GB"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/usage/bulk/meterGlobalId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```